{
*******************************************************************
 Control up to 32-Servos on any pin assignment
 Version1.2                                             05-30-2006 
*******************************************************************
 Coded by Beau Schwabe (Parallax).                                            
*******************************************************************

 Revision History:
  Version 1.0   -               Created a Working concept to control 32 servos
                                
  Version 1.1   -               Fixed a "glitch" due to 'cnt' roll over

  Version 1.2   -               Better "glitch" detection routine implemented
                                Fixed improper allocation of reserved variable space
  
}
CON
    _clkmode = xtal1 + pll16x                           
    _xinfreq = 4_000_000                                'Note Clock Speed for your setup!!

    PanServo1 = 0                                       'For DEMO only  Set servo on pin0  ; could be any pin 
    PanServo2 = 2                                       'For DEMO only  Set servo on pin2  ; could be any pin
    PanServo3 = 7                                       'For DEMO only  Set servo on pin7  ; could be any pin
    PanServo4 = 8                                       'For DEMO only  Set servo on pin8  ; could be any pin
    
OBJ
  SERVO : "Servo32"

PUB Servo32_DEMO | temp

    'Preset Servo's you want to use to center position
    SERVO.Set(PanServo1,1500)
    SERVO.Set(PanServo2,1500)
    SERVO.Set(PanServo3,1500)
    SERVO.Set(PanServo4,1500)

    'Note: Servo pins that will be used must be preset before running "SERVO.Start".
    '      This is because the I/O direction is set here and is only executed
    '      at the beginning of "SERVO.Start".  Servo pins that aren't used will remain
    '      in their original direction state.

    SERVO.Start                                         'Start Servo handler

    repeat                                              
                                                        'Pan selected DEMO servo1 back-n-forth 
     repeat temp from 1000 to 2000
      waitcnt (cnt+125_000)
      SERVO.Set(PanServo1,temp)
     repeat temp from 2000 to 1000
      waitcnt (cnt+125_000)
      SERVO.Set(PanServo1,temp)
                                                        'Pan selected DEMO servo2 back-n-forth       
     repeat temp from 1000 to 2000
      waitcnt (cnt+125_000)
      SERVO.Set(PanServo2,temp)
     repeat temp from 2000 to 1000
      waitcnt (cnt+125_000)
      SERVO.Set(PanServo2,temp)
                                                        'Pan selected DEMO servo3 & 4 back-n-forth opposite of each other
     repeat temp from 1000 to 2000
      waitcnt (cnt+125_000)
      SERVO.Set(PanServo3,temp)
      SERVO.Set(PanServo4,3000-temp)
     repeat temp from 2000 to 1000
      waitcnt (cnt+125_000)
      SERVO.Set(PanServo3,temp)
      SERVO.Set(PanServo4,3000-temp)